manjaro-tools/bin/mkchroot.in

127 lines
4.1 KiB
Text
Raw Normal View History

2014-10-04 00:46:40 +02:00
#!/bin/bash
2014-11-18 19:20:53 +01:00
#
2014-10-04 00:46:40 +02:00
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; version 2 of the License.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
2014-10-08 13:14:28 +02:00
version=@version@
2015-06-09 00:01:31 +02:00
LIBDIR='@libdir@'
[[ -r ${LIBDIR}/util-msg.sh ]] && source ${LIBDIR}/util-msg.sh
import ${LIBDIR}/util.sh
2014-10-04 00:46:40 +02:00
2014-11-12 02:19:58 +01:00
working_dir=''
2015-01-02 18:26:27 +01:00
build_locales=false
2015-06-03 17:53:13 +02:00
keep_mirrors=false
2015-06-03 18:25:31 +02:00
keep_flag=''
2014-10-04 00:46:40 +02:00
usage() {
2016-09-15 23:58:18 +02:00
echo "Usage: ${0##*/} [options] working-dir package-list..."
echo ' options:'
echo ' -C <file> Location of a pacman config file'
echo ' -M <file> Location of a makepkg config file'
echo ' -S <file> Location of a pacman-mirrors config file'
echo ' -c <dir> Set pacman cache'
echo ' -L Use build locale.gen en/de'
echo ' -B Use custom build mirror'
echo ' -K Keep mirrorlist (-B)'
echo ' -x copy pacman.conf'
echo ' -h This message'
exit 1
2014-10-04 00:46:40 +02:00
}
2014-11-12 02:19:58 +01:00
orig_argv=("$@")
opts='hLKC:M:S:c:B:'
while getopts ${opts} arg; do
2016-09-15 23:58:18 +02:00
case "${arg}" in
C) pac_conf="$OPTARG" ;;
M) makepkg_conf="$OPTARG" ;;
S) mirrors_conf="$OPTARG" ;;
c) cache_dir="$OPTARG" ;;
L) build_locales=true ;;
B) build_mirror="$OPTARG" ;;
K) keep_mirrors=true; keep_flag='-K' ;;
h|?) usage ;;
*) error "invalid argument '$arg'"; usage ;;
esac
2014-10-04 00:46:40 +02:00
done
shift $(($OPTIND - 1))
2014-11-11 21:19:26 +01:00
(( $# < 2 )) && die 'You must specify a directory and one or more packages.'
2014-10-04 00:46:40 +02:00
2014-11-12 02:19:58 +01:00
check_root "$0" "${orig_argv[@]}"
2014-11-11 21:19:26 +01:00
2014-11-12 02:19:58 +01:00
working_dir="$(readlink -f $1)"
2014-11-11 21:19:26 +01:00
shift 1
2014-10-04 00:46:40 +02:00
2014-11-12 02:19:58 +01:00
[[ -z $working_dir ]] && die 'Please specify a working directory.'
2014-10-04 00:46:40 +02:00
2014-11-12 02:19:58 +01:00
if [[ -z $cache_dir ]]; then
2016-09-15 23:58:18 +02:00
cache_dirs=($(pacman -v $cache_conf 2>&1 | grep '^Cache Dirs:' | sed 's/Cache Dirs:\s*//g'))
2014-11-12 02:19:58 +01:00
else
2016-09-15 23:58:18 +02:00
cache_dirs=(${cache_dir})
2014-11-12 02:19:58 +01:00
fi
2014-10-04 00:46:40 +02:00
2014-11-12 02:19:58 +01:00
umask 0022
2014-10-04 00:46:40 +02:00
#[[ -e $working_dir ]] && die "Working directory '%s' already exists" "$working_dir"
2014-10-04 00:46:40 +02:00
#mkdir -p "$working_dir"
2015-01-15 13:23:34 +01:00
[[ ! -d $working_dir ]] && mkdir -p "$working_dir"
2014-10-04 00:46:40 +02:00
2014-11-12 02:19:58 +01:00
lock 9 "${working_dir}.lock" "Locking chroot"
2014-10-04 00:46:40 +02:00
if is_btrfs "$working_dir"; then
rmdir "$working_dir"
if ! btrfs subvolume create "$working_dir"; then
die "Couldn't create subvolume for '%s'" "$working_dir"
fi
chmod 0755 "$working_dir"
2014-11-12 02:19:58 +01:00
fi
2014-10-04 00:46:40 +02:00
# Workaround when creating a chroot in a branch different of the host
if [[ -n $pac_conf ]] && [[ -n $mirrors_conf ]] && [[ -n ${build_mirror} ]]; then
2016-09-15 23:58:18 +02:00
url=${build_mirror}'/$repo/$arch'
[[ ${build_mirror} = *ftp*repo.manjaro.org* ]] && show_mirror=repo.manjaro.org'/$repo/$arch' || show_mirror=$url
2018-04-15 22:03:10 +02:00
info "mirror: %s" "$show_mirror"
2016-09-15 23:58:18 +02:00
pac_base="$working_dir/pacman-basestrap.conf"
sed "s#Include = /etc/pacman.d/mirrorlist#Server = ${url}#g" $pac_conf > $pac_base
2016-09-15 23:58:18 +02:00
basestrap -GMcd ${pac_base:+-C "$pac_base"} "$working_dir" \
"${cache_dirs[@]/#/--cachedir=}" "$@" || die 'Failed to install all packages'
2016-09-15 23:58:18 +02:00
[[ -f "$pac_base" ]] && rm "$pac_base"
else
2016-09-15 23:58:18 +02:00
basestrap -GMcd ${pac_conf:+-C "$pac_conf"} "$working_dir" \
"${cache_dirs[@]/#/--cachedir=}" "$@" || die 'Failed to install all packages'
fi
2015-01-08 16:19:30 +01:00
echo "$version" > "$working_dir/.manjaro-tools"
2014-11-12 02:19:58 +01:00
2018-04-14 00:07:43 +02:00
if ${build_locales}; then
2016-09-15 23:58:18 +02:00
info "Using build locales ..."
mv "$working_dir/etc/locale.gen" "$working_dir/etc/locale.gen.bak"
mv "$working_dir/etc/locale.conf" "$working_dir/etc/locale.conf.bak"
printf '%s.UTF-8 UTF-8\n' en_US > "$working_dir/etc/locale.gen"
printf 'LANG=%s.UTF-8\n' en_US > "$working_dir/etc/locale.conf"
printf 'LC_MESSAGES=C\n' >> "$working_dir/etc/locale.conf"
chroot_args=(${pac_conf:+-C "$pac_conf"} ${makepkg_conf:+-M "$makepkg_conf"} \
${mirrors_conf:+-S "$mirrors_conf"} ${build_mirror:+-B "$build_mirror"} \
${cache_dir:+-c "$cache_dir"} ${keep_flag})
2015-01-11 21:02:29 +01:00
exec chroot-run \
${chroot_args[*]} \
"$working_dir" locale-gen
fi